<?php
function payid19pos_init_payment_class_kriptopos(){
    if(!class_exists('WC_payid19Pos_Gateway_kriptopos')) return;
    class WC_payid19Pos_Payment_kriptopos extends WC_payid19Pos_Gateway_kriptopos{
        
        function payment_run($order_id){  //Ödeme yap butonuna basınca yapılacaklar
            GLOBAL $woocommerce;
            $this->core = new WC_payid19Pos_Gateway_kriptopos;
            
            $order = new WC_Order( $order_id ); //Siparişi getir
            $order->add_order_note("Payment is start: " . $order->get_order_number() ); //Sipariş Takibi
            $redirect_url = add_query_arg( 'wc-api', $this->core->id, get_site_url()."/" ); //Sipariş Dönüş Adresi
            
            $hata = 0;
            
            /*----------  İşlem Tutarı Ayarlama  ----------*/
            $toplami = $order->get_total();
            $Amount = number_format($toplami, 2, ".", "");
            $Currency = get_woocommerce_currency();
            
            $order->add_order_note("Amount: " . $Amount . " " . $Currency); //Sipariş Takibi
            
            /*----------  Para Birimi Kontrolü  ----------*/
            if (!in_array($Currency, array("USD","EUR","JPY","GBP","CAD","AUD","CHF","TRY","RUB","CNY","AED","AFN","ALL","AMD","ANG","AOA","ARS","AWG","AZN","BAM","BBD","BCH","BDT","BGN","BHD","BIF","BMD","BND","BOB","BRL","BSD","BTC","BTG","BWP","BZD","CDF","CLP","CNH","COP","CRC","CUC","CUP","CVE","CZK","DASH","DJF","DKK","DOP","DZD","EGP","EOS","ETB","ETH","FJD","GEL","GHS","GIP","GMD","GNF","GTQ","GYD","HKD","HNL","HRK","HTG","HUF","IDR","ILS","INR","IQD","IRR","ISK","JMD","JOD","KES","KGS","KHR","KMF","KRW","KWD","KYD","KZT","LAK","LBP","LKR","LRD","LSL","LTC","LYD","MAD","MDL","MKD","MMK","MOP","MUR","MVR","MWK","MXN","MYR","MZN","NAD","NGN","NIO","NOK","NPR","NZD","OMR","PAB","PEN","PGK","PHP","PKR","PLN","PYG","QAR","RON","RSD","RWF","SAR","SBD","SCR","SDG","SEK","SGD","SLL","SOS","SRD","SVC","SZL","THB","TJS","TMT","TND","TOP","TTD","TWD","TZS","UAH","UGX","UYU","UZS","VND","XAF","XAG","XAU","XCD","XLM","XOF","XRP","YER","ZAR","ZMW") ) ) {
                $hata = 1;
                wc_add_notice( "Currency Error, please visit payid19.com and show supported currencies", 'error' );
            }
            
            /*----------  Pos Verileri Ayarlama  ----------*/
            $OkUrl = $redirect_url; //Başarılı sonuç alınırsa, yönlendirilecek sayfa
            $UserName = $this->core->api_user; // Web Yönetim ekranlarından olusturulan api rollü kullanici
            $Password = $this->core->api_pass; // Web Yönetim ekranlarından olusturulan api rollü kullanici şifre
            //$posTitle = $this->core->postitle; // Web Yönetim ekranlarından olusturulan api rollü kullanici şifre
            //$posDesc = $this->core->posdescription; // Web Yönetim ekranlarından olusturulan api rollü kullanici şifre
            $payGate = $this->core->url_paygate; // Web Yönetim ekranlarından olusturulan api rollü kullanici şifre
            $timeout = $this->core->timeout; // Fatura geçerlilik süresi - saat
            $customer_id=$order->get_user_id();
            if ( !is_numeric($timeout) ) { //Geçerlilik süresi hatalıysa default 24 saat olarak ayarla
                $timeout = 24;
            }
            
            $testMode = $this->core->testMode; //Test faturası mı?
            if ($testMode == "yes") {
                $testMode = 1;
            } else {
                $testMode = null;
            }
            
            $faturaMail = $order->get_billing_email();
            
            //Gönderilecek POST verisi oluşturma başladı
            $url= $payGate;
            
            $post = [
                'public_key' => $UserName,
                'private_key' => $Password,
                'email' => $faturaMail,
                'price_amount' => $Amount,
                'price_currency' => $Currency,
                'order_id' => $order_id,
                'test' => $testMode,
                //'title' => $posTitle,
                //'description' => $posDesc,
                'customer_id'=>$customer_id,
                'cancel_url' => $OkUrl . "cancel",
                'success_url' => $OkUrl . "ok",
                'callback_url' => $OkUrl,
                'expiration_date' => $timeout
            ];

            $result = wp_remote_post($url,array(
                'method'      => 'POST',
                'timeout'     => 45,
                'redirection' => 5,
                'httpversion' => '1.0',
                'blocking'    => true,
                'headers'     => array(),
                'body'        => $post,
                'cookies'     => array()
                )
            );
            

            if(json_decode($result['body'])->status=='error'){

                $gelenHata = json_decode($result['body'])->message[0];
                wc_add_notice( $gelenHata, 'error' );
                $order->add_order_note("Error: " . $gelenHata); //Sipariş Takibi
                $hata = 1;
            } else {
                $order->add_order_note("Customer redirected payment page."); //Sipariş Takibi
                session_start();
                $_SESSION['kriptoposxml'] = json_decode($result['body'])->message;
            }
            
            if ($hata == 0) { //Hata yoksa işleme devam et
                return array(
                    'result' => 'success',
                    'redirect' => $order->get_checkout_payment_url(true)
                );
            } elseif ($hata == 1) { //Hata varsa dur
                return array(
                    'result' => 'failure',
                    'redirect' => ''
                );
            }
            
        } //Function payment_run
        
    } //Class WC_payid19Pos_Payment
        
} //Function payid19pos_init_payment_class

add_action('plugins_loaded', 'payid19pos_init_payment_class_kriptopos' , 1);